import  request  from '@/utils/request'
import axios from 'axios'

/**
 * 获取文件列表
 * @param { pageNo,pageSize } pageNo页码 pageSize每页条数
 * @returns
 */
export const fileList = (pageNo: any, pageSize: any, status: any) => {
  return request({
    url: `/api-file/files/`,
    params: {
      pageNo,
      pageSize,
      status
    },
    method: 'GET'
  })
}
/**
 * 通过id获取文件
 * @param {} id
 * @returns
 */
export const uploadFileInfo = (id: any) => {
  return request({
    url: `/api-file/files/info/${id}`,
    method: 'GET',
    //不需要令牌
    headers: {
      isToken: false
    }
  })
}

/**
 * 预签-上传文件
 * @param {"module":"","name": ""} data
 * @returns
 */
export const preSigned = (data: any) => {
  return request({
    url: '/api-file/files/presigned',
    method: 'POST',
    data
  })
}
/**
 * 预签-上传文件结束标记
 * @param {[]} params
 * @returns
 */
export const finished = (fileIds: any) => {
  return request({
    url: '/api-file/files/finished',
    method: 'POST',
    data: {
      fileIds
    }
  })
}

/* 文件删除 */
export const deleteFile = (id: any) => {
  return request({
    url: `/api-file/files/${id}`,
    method: 'DELETE'
  })
}

/**
 * 上传二进制文件
 * @param {} url
 * @param {*} file
 * @returns
 */
export const uploadBinary = (url: any, file: any) => {
  return axios.put(url, file, {
    headers: {
      'Content-Type': 'multipart/form-data'
    }
  })
}

export const download = (id: any) => {
  return request({
    url: `/api-file/files/download/${id}`,
    method: 'GET'
  })
}
