import request from '@/utils/request'

// 获取用户分页列表
export const getUserList = (pageNo, pageSize) => {
  return request({
    url: `/api-user/system/user/list`,
    method: 'get',
    params: {
      pageNo,
      pageSize
    }
  })
}

// 查询场景列表
export const getSceneList = (apiCode) => {
  return request({
    url: `/api-user/user/scene/list-bycode?apiCode=${apiCode}`,
    method: 'get'
  })
}

// 数据列的源数据
export const getDynamicList = (apiCode, sceneId) => {
  const url =
    sceneId == null
      ? `/api-user/user/dynamic/col/list-bycode?apiCode=${apiCode}`
      : `/api-user/user/dynamic/col/list-bycode?apiCode=${apiCode}&sceneId=${sceneId}`
  return request({
    url: url,
    method: 'get'
  })
}

// 新增场景
export const saveScene = (data) => {
  return request({
    url: '/api-user/user/scene/save',
    method: 'post',
    data: data
  })
}

// 设置默认场景
export const setDefualt = (sceneId, apiCode) => {
  return request({
    url: `/api-user/user/scene/setDefualt?sceneId=${sceneId}&apiCode=${apiCode}`,
    method: 'put'
    // data: data
  })
}

// 更新场景
export const updateScene = (data) => {
  return request({
    url: '/api-user/user/scene/update',
    method: 'put',
    data: data
  })
}

// 删除场景
export const deleteScene = (data) => {
  return request({
    url: '/api-user/user/scene/delete',
    method: 'DELETE',
    data: data
  })
}
