import svg from '../../images'
const imgUrl: any = svg
/* 绘制模板 */
export function drawTemplate(variable: any, go: any, myContextMenu: any) {
  /* 文字样式样式函数 */
  function textStyle(style = {}) {
    return {
      font: 'Microsoft YaHei UI' /* 字体 */,
      stroke: 'rgba(23, 26, 29, 0.6)' /* 字体颜色 */,
      editable: true /* 文本是否可编辑 */,
      margin: 0,
      overflow: go.TextBlock.OverflowEllipsis,
      maxLines: 1,
      ...style
    }
  }
  function maxWidthFormat(text: any) {
    const canvas = document.createElement('canvas')
    const context: any = canvas.getContext('2d')
    context.font = 'Microsoft YaHei UI'
    return new go.Size(context.measureText(text).width + 15, NaN)
  }
  function maxWidthFormat2(text: any) {
    const canvas = document.createElement('canvas')
    const context: any = canvas.getContext('2d')
    context.font = 'Microsoft YaHei UI'
    return new go.Size(context.measureText(text).width + 43, 22)
  }
  /* 记录线位置信息 */
  function nodeStyle() {
    return [
      new go.Binding('location', 'loc', go.Point.parse).makeTwoWay(go.Point.stringify),
      { locationSpot: go.Spot.Center }
    ]
  }
  /* 连线模块样式控制 */
  function makePort(name: any, align: any, spot: any, output: any, input: any) {
    const horizontal = align.equals(go.Spot.Top) || align.equals(go.Spot.Bottom)
    return go.GraphObject.make(go.Shape, {
      fill: 'transparent',
      strokeWidth: 0,
      width: horizontal ? NaN : 8,
      height: !horizontal ? NaN : 8,
      alignment: align,
      stretch: horizontal ? go.GraphObject.Horizontal : go.GraphObject.Vertical,
      portId: name,
      fromSpot: spot,
      fromLinkable: output,
      toSpot: spot,
      toLinkable: input,
      cursor: 'pointer',
      mouseEnter: function (e: any, port: any) {
        if (!e.diagram.isReadOnly) port.fill = 'rgba(255,0,255,0.5)'
      },
      mouseLeave: function (e: any, port: any) {
        port.fill = 'transparent'
      }
    })
  }
  /* 图片加载 */
  function findHeadShot(img: any) {
    return imgUrl[img ? img : 'process']
  }
  /* 添加公用节点模板(矩形) */
  variable.nodeTemplateMap.add(
    '',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        { desiredSize: new go.Size(120, 50) },
        go.GraphObject.make(go.Shape, 'RoundedRectangle', {
          fill: 'rgba(185, 99, 211, 0.12)',
          maxSize: new go.Size(120, 50),
          stroke: 'rgb(185, 99, 211)' /* 边距颜色 */,
          strokeWidth: 2
        }),
        go.GraphObject.make(
          go.TextBlock,
          textStyle({ stroke: 'rgb(185, 99, 211)' }),
          {
            maxSize: new go.Size(140, NaN),
            wrap: go.TextBlock.WrapFit,
            editable: true,
            margin: 5
          },
          new go.Binding('text').makeTwoWay()
        )
      ),
      makePort('T', go.Spot.Top, go.Spot.TopSide, true, true),
      makePort('L', go.Spot.Left, go.Spot.LeftSide, true, true),
      makePort('R', go.Spot.Right, go.Spot.RightSide, true, true),
      makePort('B', go.Spot.Bottom, go.Spot.BottomSide, true, true)
    )
  )
  /* 开始圆圈 */
  variable.nodeTemplateMap.add(
    'start',
    go.GraphObject.make(
      go.Node,
      'Table',
      { contextMenu: myContextMenu ? myContextMenu : null },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        { desiredSize: new go.Size(70, 70) },
        go.GraphObject.make(go.Shape, 'Circle', {
          fill: 'rgba(0, 137, 255, 0.12)' /* 背景颜色 */,
          maxSize: new go.Size(150, 150),
          stroke: 'rgb(0, 137, 255)',
          strokeWidth: 2
        }),
        go.GraphObject.make(
          go.TextBlock,
          textStyle({ stroke: 'rgb(0, 137, 255)' }),
          {
            maxSize: new go.Size(140, NaN),
            wrap: go.TextBlock.WrapFit,
            editable: true,
            margin: 5
          },
          new go.Binding('text').makeTwoWay()
        )
      ),
      makePort('T', go.Spot.Top, go.Spot.TopSide, true, false),
      makePort('L', go.Spot.Left, go.Spot.LeftSide, true, false),
      makePort('R', go.Spot.Right, go.Spot.RightSide, true, false),
      makePort('B', go.Spot.Bottom, go.Spot.BottomSide, true, false)
    )
  )
  /* 结束园 */
  variable.nodeTemplateMap.add(
    'end',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Spot',
        { desiredSize: new go.Size(70, 70) },
        go.GraphObject.make(go.Shape, 'Circle', {
          fill: 'rgba(0, 137, 255, 0.12)' /* 背景颜色 */,
          maxSize: new go.Size(150, 150),
          stroke: 'rgb(0, 137, 255)',
          strokeWidth: 2
        }),
        go.GraphObject.make(
          go.TextBlock,
          textStyle({ stroke: 'rgb(0, 137, 255)' }),
          {
            maxSize: new go.Size(140, NaN),
            wrap: go.TextBlock.WrapFit,
            editable: true,
            margin: 5
          },
          new go.Binding('text').makeTwoWay()
        )
      ),
      makePort('T', go.Spot.Top, go.Spot.TopSide, false, true),
      makePort('L', go.Spot.Left, go.Spot.LeftSide, false, true),
      makePort('R', go.Spot.Right, go.Spot.RightSide, false, true),
      makePort('B', go.Spot.Bottom, go.Spot.BottomSide, false, true)
    )
  )
  /* 菱形 */
  variable.nodeTemplateMap.add(
    'rhombus',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        { desiredSize: new go.Size(150, 70) },
        go.GraphObject.make(
          go.Shape,
          'Diamond',
          {
            fill: 'rgba(244, 200, 0, 0.12)',
            maxSize: new go.Size(150, 140),
            stroke: 'rgba(244, 200, 0, 1)',
            strokeWidth: 2
          },
          new go.Binding('figure', 'figure')
        ),
        go.GraphObject.make(
          go.TextBlock,
          textStyle({ stroke: 'rgba(244, 200, 0, 1)' }),
          {
            maxSize: new go.Size(140, NaN),
            wrap: go.TextBlock.WrapFit,
            editable: true,
            margin: 5
          },
          new go.Binding('text').makeTwoWay()
        )
      ),
      makePort('T', go.Spot.Top, go.Spot.Top, false, true),
      makePort('L', go.Spot.Left, go.Spot.Left, true, true),
      makePort('R', go.Spot.Right, go.Spot.Right, true, true),
      makePort('B', go.Spot.Bottom, go.Spot.Bottom, true, false)
    )
  )
  /* 开始自定义小图标 */
  variable.nodeTemplateMap.add(
    'startCard',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        /* 菜单 */
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        new go.Binding('desiredSize', 'text', maxWidthFormat2),
        /* 确定形状 */
        go.GraphObject.make(go.Shape, 'RoundedRectangle', {
          fill: 'rgb(149, 172, 206)',
          stroke: 'rgba(0, 0, 0, 0.16)',
          strokeWidth: 2
        }),
        /* 嵌套图片和文字 */
        go.GraphObject.make(
          go.Panel,
          'Horizontal',
          new go.Binding('desiredSize', 'text', maxWidthFormat2),
          /* 图片位置 */
          go.GraphObject.make(
            go.Picture,
            {
              desiredSize: new go.Size(16, 16),
              margin: 5
            },
            new go.Binding('source', 'img', findHeadShot)
          ),
          /* 右边文字渲染 */
          go.GraphObject.make(
            go.TextBlock,
            textStyle({
              editable: false
            }),
            new go.Binding('maxSize', 'text', maxWidthFormat),
            new go.Binding('text').makeTwoWay()
          )
        )
      ),
      /* 添加线 */
      // makePort("T", go.Spot.Top, go.Spot.Top, false, false),
      makePort('L', go.Spot.Left, go.Spot.Left, true, false),
      makePort('R', go.Spot.Right, go.Spot.Right, true, false)
      // makePort("B", go.Spot.Bottom, go.Spot.Bottom, false, false)
    )
  )
  /* 结束自定义小图标 */
  variable.nodeTemplateMap.add(
    'endCard',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        /* 菜单 */
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        new go.Binding('desiredSize', 'text', maxWidthFormat2),
        go.GraphObject.make(go.Shape, 'RoundedRectangle', {
          fill: 'rgb(149, 172, 206)',
          stroke: 'rgba(0, 0, 0, 0.16)',
          strokeWidth: 2
        }),
        go.GraphObject.make(
          go.Panel,
          'Horizontal',
          new go.Binding('desiredSize', 'text', maxWidthFormat2),
          /* 图片位置 */
          go.GraphObject.make(
            go.Picture,
            {
              desiredSize: new go.Size(16, 16),
              margin: 5
            },
            new go.Binding('source', 'img', findHeadShot)
          ),
          /* 右边文字渲染 */
          go.GraphObject.make(
            go.TextBlock,
            textStyle({
              // maxSize: new go.Size(40, NaN),
              editable: false
            }),
            new go.Binding('maxSize', 'text', maxWidthFormat),
            new go.Binding('text').makeTwoWay()
          )
        )
      ),
      /* 添加线 */
      // makePort("T", go.Spot.Top, go.Spot.Top, false, false),
      makePort('L', go.Spot.Left, go.Spot.Left, false, true),
      makePort('R', go.Spot.Right, go.Spot.Right, false, true)
      // makePort("B", go.Spot.Bottom, go.Spot.Bottom, false,false)
    )
  )
  /* 通用自定义小图标 */
  variable.nodeTemplateMap.add(
    'universalCard',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        /* 菜单 */
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        new go.Binding('desiredSize', 'text', maxWidthFormat2),
        go.GraphObject.make(go.Shape, 'RoundedRectangle', {
          fill: 'rgb(149, 172, 206)',
          stroke: 'rgba(0, 0, 0, 0.16)',
          strokeWidth: 2
        }),
        go.GraphObject.make(
          go.Panel,
          'Horizontal',
          new go.Binding('desiredSize', 'text', maxWidthFormat2),
          /* 图片位置 */
          go.GraphObject.make(
            go.Picture,
            {
              desiredSize: new go.Size(16, 16),
              margin: 5
            },
            new go.Binding('source', 'img', findHeadShot)
          ),
          /* 右边文字渲染 */
          go.GraphObject.make(
            go.TextBlock,
            textStyle({
              // maxSize: new go.Size(40, NaN),
            }),
            new go.Binding('maxSize', 'text', maxWidthFormat),
            new go.Binding('text').makeTwoWay()
          )
        )
      ),
      /* 添加线 */
      // makePort("T", go.Spot.Top, go.Spot.Top, false, false),
      makePort('L', go.Spot.Left, go.Spot.Left, true, true),
      makePort('R', go.Spot.Right, go.Spot.Right, true, true)
      // makePort("B", go.Spot.Bottom, go.Spot.Bottom, false, false)
    )
  )
  /* 通用自定义小图标备份 */
  variable.nodeTemplateMap.add(
    'universalIcon',
    go.GraphObject.make(
      go.Node,
      'Table',
      {
        /* 菜单 */
        contextMenu: myContextMenu ? myContextMenu : null
      },
      nodeStyle(),
      go.GraphObject.make(
        go.Panel,
        'Auto',
        {
          /* 大小 */
          desiredSize: new go.Size(68, 22)
        },
        go.GraphObject.make(go.Shape, 'RoundedRectangle', {
          fill: 'rgb(149, 172, 206)',
          stroke: 'rgba(0, 0, 0, 0.16)',
          strokeWidth: 2
        }),
        go.GraphObject.make(
          go.Panel,
          'Horizontal',
          {
            desiredSize: new go.Size(68, NaN)
          },
          /* 图片位置 */
          go.GraphObject.make(
            go.Picture,
            {
              desiredSize: new go.Size(16, 16),
              margin: 5
            },
            new go.Binding('source', 'img', findHeadShot)
          ),
          /* 右边文字渲染 */
          go.GraphObject.make(
            go.TextBlock,
            textStyle({
              maxSize: new go.Size(40, NaN)
            }),
            new go.Binding('text').makeTwoWay()
          )
        )
      ),
      /* 添加线 */
      // makePort("T", go.Spot.Top, go.Spot.Top, false, false),
      makePort('L', go.Spot.Left, go.Spot.Left, true, true),
      makePort('R', go.Spot.Right, go.Spot.Right, true, true)
      // makePort("B", go.Spot.Bottom, go.Spot.Bottom, false, false)
    )
  )
}
