import svg from '../../images'
const imgUrl: any = svg
/* 绘制模板 */
export function drawTemplate(variable: any, go: any) {
  /* 文字样式样式函数 */
  function textStyle(style = {}) {
    return {
      font: 'normal 13px Microsoft YaHei UI',
      stroke: '#171A1DFF' /* 字体颜色 */,
      editable: false /* 文本是否可编辑 */,
      margin: 0,
      overflow: go.TextBlock.OverflowEllipsis,
      maxLines: 1,
      ...style
    }
  }
  /* 图片加载 */
  function findHeadShot(img: any) {
    return imgUrl[img ? img : 'suspend']
  }
  /* 纯文本 */
  variable.nodeTemplateMap.add(
    'universalCard',
    go.GraphObject.make(
      go.Node,
      'Table',
      /* 文字渲染 */
      go.GraphObject.make(
        go.TextBlock,
        textStyle({ maxSize: new go.Size(NaN, NaN) }),
        new go.Binding('text').makeTwoWay()
      )
    )
  )
  /* 图标 */
  variable.nodeTemplateMap.add(
    'universalIcon',
    go.GraphObject.make(
      go.Node,
      'Table',
      /* 图标 */
      go.GraphObject.make(
        go.Picture,
        {
          desiredSize: new go.Size(24, 24)
        },
        new go.Binding('source', 'img', findHeadShot)
      )
    )
  )
}
